
refwaarden.data.resultset = {

    results : null,
	scrollToId : 0,

    list : function(scrollToId){
        var self = this;

		self.scrollToId = scrollToId;

		refwaarden.data.install.db.transaction(function(tx){self.getList(tx)}, function(err){self.errorCB(err)});
    },

    getList : function(tx) {
		var self = this;

        if (self.results){
            // cached data
            self.getListSuccess(null, self.results);
            return;
        }
		/*
		SELECT h.id, h.titel, f.id,
		CASE WHEN f.id IS NOT NULL THEN 1 ELSE 0 END AS favo,
		CASE WHEN n.hoofdrubriek IS NOT NULL THEN 1 ELSE 0 END AS notitie
		FROM hoofdrubriek h
		LEFT JOIN favorites f ON h.id = f.id
		LEFT JOIN notities n ON h.id = n.hoofdrubriek
		ORDER BY h.titel
		*/



        //tx.executeSql('SELECT * FROM hoofdrubriek ORDER BY titel', [], function(tx, results){self.getListSuccess(tx, results)}, function(err){self.errorCB(err)});
        tx.executeSql('SELECT h.id, h.titel, CASE WHEN f.id IS NOT NULL THEN 1 ELSE 0 END AS favo, CASE WHEN n.hoofdrubriek IS NOT NULL THEN 1 ELSE 0 END AS notitie FROM hoofdrubriek h LEFT JOIN favorites f ON h.id = f.id LEFT JOIN notities n ON h.id = n.hoofdrubriek ORDER BY h.titel', [], function(tx, results){self.getListSuccess(tx, results)}, function(err){self.errorCB(err)});
	},


    getListSuccess : function(tx, results) {

        var self = this;

        // cache data in object
        if (!self.results){
            self.results = results;
        }

		// create a <ul> container to append the data to
        $('#resultset').html('').append('<ul class="list" />');

		var len = results.rows.length;
		var sPrevFirstChar = '';

		for (var i=0; i<len; i++){

			// blauwe tussenkopjes plaatjes voor elke letter van het alfabet
			sFirstChar = results.rows.item(i).titel.substring(0,1);
			if(sFirstChar != sPrevFirstChar){
				$('#resultset ul').append('<li class="subheader">' + sFirstChar +'</li>');
			}
			sPrevFirstChar = sFirstChar;

		    // format the items
			sClass = '';
			if(results.rows.item(i).favo == 1) sClass = 'favorite';
			if(results.rows.item(i).notitie == 1) sClass = 'note';
			if(results.rows.item(i).favo == 1 && results.rows.item(i).notitie == 1) sClass = 'favorite note';


	        $('#resultset ul').append('<li><a href="#" id="item-' + results.rows.item(i).id + '" data-id="' + results.rows.item(i).id + '" class="'+sClass+'" >' + results.rows.item(i).titel + '</a></li>');
		}

        // in scrollToId staat het id van het item in de lijst waar naartoe gescrolled moet worden zodra de lijst ingeladen is
        if(self.scrollToId > 0){
			iScroll = $('#item-'+self.scrollToId).offset().top; // de positie opvragen van het item in de lijst
			iPadding = parseInt($('#content').css('padding-top'), 10); // de padding-top eraf halen (ivm de titelbalk en zoekformulier)
			$('html, body').scrollTop(iScroll - iPadding); // en scrollen maar!
        }
	},

	errorCB : function (err) {
	    alert("Error processing SQL: "+err.code + " " + err.message);
	}

}

