refwaarden.favorites = {

	init : function(){

        var self = this;

        // button: add to favorites
        $('#btn-favorites-add').click(function(e) {
			e.preventDefault();
            self.add($(this).data('id'));
        });

        // button: remove from favorites
        $('#btn-favorites-remove').click(function(e) {
			e.preventDefault();
            self.remove($(this).data('id'));
        });

        // button: show favorites
        $('#btn-favorites').click(function(e) {
			e.preventDefault();
			refwaarden.navigation.setState('favorites');
        });

        self.toggleListButton();

    },


	// Favoriet toevoegen
	add : function(id){

		var self = this;

		refwaarden.data.install.db.transaction(function(tx){
			// het stukje "OR IGNORE" zorgt ervoor dat je geen foutmelding krijgt al het id al in de favorieten tabel staat
			tx.executeSql('INSERT OR IGNORE INTO favorites (id) VALUES ('+id+')');
		}, function(err){self.errorCB(err)}, function(){self.addSuccess()});
	},

	addSuccess : function(){
		var self = this;
		self.toggleFavorite();
		self.toggleListButton();

		refwaarden.data.resultset.results = null; // cache legen
	},

	// Favoriet verwijderen
	remove : function(id){
		var self = this;

		refwaarden.data.install.db.transaction(function(tx){

			tx.executeSql('DELETE FROM favorites WHERE id = '+id);
		}, function(err){self.errorCB(err)}, function(){self.removeSuccess()});
	},

	removeSuccess : function(){
		var self = this;
		self.toggleFavorite();
		self.toggleListButton();
	},

	// controleren of de huidige referentiewaarde als favoriet is opgeslagen
	toggleFavorite : function(){
		var self = this;
		var id = $('#btn-favorites-add').data('id');


		refwaarden.data.install.db.transaction(function(tx){
			tx.executeSql('SELECT id FROM favorites WHERE id = ' + id, [], function(tx, results){self.toggleFavoriteSuccess(tx, results)}, function(err){self.errorCB(err)} );
		});
	},

	toggleFavoriteSuccess : function(tx, results) {

		if(results.rows.length > 0){
			// het is een favoriet
			$('#item div.info.title').addClass('favorite');
			$('#btn-favorites-add').hide();
			$('#btn-favorites-remove').show();
		} else {
			// geen favoriet
			$('#item div.info.title').removeClass('favorite');
			$('#btn-favorites-add').show();
			$('#btn-favorites-remove').hide();
		}

	},

	// controleren of er favorieten zijn
	toggleListButton : function(){
		var self = this;

		refwaarden.data.install.db.transaction(function(tx){
			tx.executeSql('SELECT id FROM hoofdrubriek WHERE id IN (SELECT id FROM favorites) LIMIT 1', [], function(tx, results){self.toggleListButtonSuccess(tx, results)}, function(err){self.errorCB(err)} );
		});
	},

	toggleListButtonSuccess : function(tx, results) {

		if(results.rows.length > 0){
			// er zijn favorieten -> "list" knop tonen
			$('#btn-favorites').show();
		} else {
			// geen favorieten -> "list" knop verbergen
			$('#btn-favorites').hide();
		}

	},


	// lijst met favorieten tonen
    list : function(q){

        var self = this;

		refwaarden.data.install.db.transaction(function(tx){
			tx.executeSql('SELECT h.id, h.titel, CASE WHEN f.id IS NOT NULL THEN 1 ELSE 0 END AS favo, CASE WHEN n.hoofdrubriek IS NOT NULL THEN 1 ELSE 0 END AS notitie FROM hoofdrubriek h LEFT JOIN favorites f ON h.id = f.id LEFT JOIN notities n ON h.id = n.hoofdrubriek WHERE h.id IN (SELECT id FROM favorites) ORDER BY h.titel', [], refwaarden.data.resultset.getListSuccess, refwaarden.data.resultset.errorCB);
		});
    },


	errorCB : function (err) {
	    alert("Error processing SQL: "+err.code + " " + err.message);
	}

}