refwaarden.navigation = {

    init : function(){
        var self = this;

        // page / state navigation
        var action = 'click';
        /*if ('ontouchstart' in document.documentElement) {
            action = 'touchstart';
        }*/

        // buttons have touchstart action. Not draggable or scrollable but very direct navigation
        $('body').delegate('a[rel="button"]', action, function(event) {
            var state = $(this).data('state');

            if($(this).data('id') != ''){
				self.setState(state, $(this).data('id'));
            } else {
            	self.setState(state);
            }

            event.preventDefault();
            return false;
        });

        $('#btn-back').click(function(event) {

        	if($('#q').val() != ''){
        		$('#search').show();
				$('body').addClass('has-search');
        		refwaarden.search.search($('#q').val());
        	} else {
	            var id = $(this).data('id');
	            self.setState('fulllist', id);
			}

            event.preventDefault();
            return false;
        });

        // resultset rows, open hoofdrubriek with id
        $('body').delegate('#resultset a', 'click', function(event) {
            var id = $(this).data('id');
            self.setState('item', id);

            event.preventDefault();
            return false;
        });

		// klik op menu knop: opent/sluit het menu
		$('#btn-menu').click(function(event){

			if($('#menu').css('display') == 'block'){
				$('#menu').hide();
				$('body').removeClass('menu');
			} else {
				$('#menu').show();
				$('body').addClass('menu');
			}

			event.preventDefault();
            return false;
		});

		// klik op zoek knop: opent/sluit de searchbar
		$('#btn-search').click(function(event){

			if($('#search').css('display') == 'block'){
				$('#search').hide();
				$('body').removeClass('has-search');
			} else {
				$('#search').show();
				$('#q').focus();
				$('body').addClass('has-search');
			}

			event.preventDefault();
            return false;
		});


    },

    /**
    *   Set the body class and load the corresponding view
    */
    setState : function(state, id){
        var self = this;

        // set the state as body class
        var states = ['activate', 'fulllist', 'item', 'search', 'favorites', 'menu', 'page', 'loading'];
        $.each(states, function(i, val){
            $('body').removeClass(val);
        });
        $('body').addClass(state);

        //$('#menu li').removeClass('active');

        // empty contents
        $('#content').html('');
        $('#toolbar').hide(); // gewoon brute force hiden!

        // load contents
        $('#content').load('views/' + state + '.html', function(){

            switch (state){
				case 'activate' :
                    refwaarden.activate.init(id);
                    break;
                case 'fulllist' :
                    // query db and display results in div#resultset
                    refwaarden.data.resultset.list(id);
                    break;
                case 'item' :
                    // load item
                    refwaarden.data.result.get(id);
                    break;
                case 'page' :
                    // load paginatekst
                    refwaarden.page.getPage(id);
                    break;
                case 'favorites' :
                	// als het menu open staat: dat eerst sluiten
                	$('#menu').hide();
					$('body').removeClass('menu');

                    // query db and display results in div#resultset
                    refwaarden.favorites.list();
                    break;
            }

        });

    }
}
