refwaarden.notes = {

	init : function(){

        var self = this;

        // button: notitie maken/bewerken
        $('#btn-note').click(function(e) {
			e.preventDefault();
            self.edit($(this).data('id'));
        });

        // submit buttons
        $('body').delegate('#note-form', 'submit', function(event) {

            self.add();

            event.preventDefault();
            return false;
        });

    },


	// notitie opslaan
	add : function(){
		var self = this;

		// toolbar weer tonen
		$('#toolbar').show();

		id = $('#btn-note').data('id');
		tekst = $('#note-textarea').val();
		tekst = tekst.replace(/'/g, "\\'");

		if(tekst == ''){
			self.remove(id);
			$('html, body').scrollTop(1); // iphone fix

		} else {
			refwaarden.data.install.db.transaction(function(tx){
				tx.executeSql("INSERT OR REPLACE INTO notities (hoofdrubriek, tekst) VALUES (?,?)", [id, tekst]);
			}, function(err){self.errorCB(err)}, function(){self.addSuccess()});
		}
	},

	addSuccess : function(){
		var self = this;
		$('html, body').scrollTop(1); // iphone fix
		self.showNote(); // notitie opnieuw inladen nadat deze is opgeslagen

		refwaarden.data.resultset.results = null; // cache legen
	},

	// notitie bewerken
	edit : function(id){
		// notitie verbergen
		$('#note').hide();

		// taakbalk verbergen
		$('#toolbar').hide();

		// notitie bewerken formulier tonen
		$('#note-form').show();
		$('#note-textarea').focus();
	},

	// notitie verwijderen
	remove : function(id){
		var self = this;

		refwaarden.data.install.db.transaction(function(tx){

			tx.executeSql('DELETE FROM notities WHERE hoofdrubriek = '+id);
		}, function(err){self.errorCB(err)}, function(){self.removeSuccess()});
	},

	removeSuccess : function(){
		var self = this;
		self.showNote(); // notitie opnieuw inladen nadat deze is verwijderd
	},

	// kijken of er een notitie is opgeslagen voor de huidige hoofdrubriek
	showNote : function(){
		var self = this;
		var id = $('#btn-note').data('id');

		$('#note-form').hide();

		refwaarden.data.install.db.transaction(function(tx){
			tx.executeSql('SELECT tekst FROM notities WHERE hoofdrubriek = ' + id, [], function(tx, results){self.showNoteSuccess(tx, results)}, function(err){self.errorCB(err)} );
		});
	},

	showNoteSuccess : function(tx, results) {
		var self = this;

		$('#toolbar').show(); // dit staat hier voor het geval iemand op "edit" heeft gedrukt - en daarmee de toolbar heeft verborgen - maar daarna nooit meer op opslaan heeft gedrukt - waardoor dus de toolbar niet meer zichtbaar wordt.

		if(results.rows.length > 0){
			// er is een notitie
			tekst = self.nl2br(results.rows.item(0).tekst);

			$('#note-textarea').val(results.rows.item(0).tekst);
			$('#note').html('<h2>Notitie</h2>'+tekst);
			$('#note').show();
			$('#item div.info.title').addClass('note');
		} else {
			// geen notitie
			$('#note').html();
			$('#note').hide();
			$('#item div.info.title').removeClass('note');
		}
	},

	errorCB : function (err) {
	    alert("Error processing SQL: "+err.code + " " + err.message);
	},

	nl2br : function(str) {
	    return (str + '').replace(/([^>\r\n]?)(\r\n|\n\r|\r|\n)/g, '$1<br>$2');
	}

}